!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!##################
MODULE MODN_ISBA_n
!##################
!
!!****  *MODN_ISBA_n* - declaration of namelist NAM_ISBA_n
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_ISBA_n
!     which concern the surface configuration of one nested  model.
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004                    
!!      Modified    08/2009 by B. Decharme : LSURF_BUDGETC for all tiles
!!      Modified by A.L. Gibelin, 04/2009: add carbon spinup
!!
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_DIAG_ISBA_n, ONLY: &
           XDIAG_TSTEP_n => XDIAG_TSTEP, &
           N2M_n => N2M, &
           L2M_MIN_ZS_n => L2M_MIN_ZS, &
           LPGD_n => LPGD, &
           LSURF_BUDGET_n => LSURF_BUDGET, &
           LRAD_BUDGET_n => LRAD_BUDGET,          &
           LCOEF_n => LCOEF, &
           LSURF_VARS_n => LSURF_VARS, &
           LPATCH_BUDGET_n => LPATCH_BUDGET  
USE MODD_DIAG_EVAP_ISBA_n, ONLY: &
           LSURF_BUDGETC_n => LSURF_BUDGETC, &
           LRESET_BUDGETC_n => LRESET_BUDGETC, &
           LSURF_EVAP_BUDGET_n => LSURF_EVAP_BUDGET, &  
           LWATER_BUDGET_n => LWATER_BUDGET  
USE MODD_CH_ISBA_n, ONLY: &
           LCH_NO_FLUX_n => LCH_NO_FLUX, &
           LCH_BIO_FLUX_n => LCH_BIO_FLUX, &
           CCH_DRY_DEP_n => CCH_DRY_DEP,   &
           CCHEM_SURF_FILE_n => CCHEM_SURF_FILE  
USE MODD_DIAG_MISC_ISBA_n, ONLY: &
           LSURF_MISC_BUDGET_n => LSURF_MISC_BUDGET, &
           LSURF_MISC_DIF_n => LSURF_MISC_DIF
USE MODD_ISBA_n, ONLY: &
           CC1DRY_n => CC1DRY, &
           CSCOND_n => CSCOND, &
           CSOILFRZ_n => CSOILFRZ, &
           CDIFSFCOND_n => CDIFSFCOND, &
           CSNOWRES_n => CSNOWRES, &
           CALBEDO_n => CALBEDO, &
           CROUGH_n => CROUGH, &
           CCPSURF_n => CCPSURF, &
           XTSTEP_n => XTSTEP, &
           XOUT_TSTEP_n => XOUT_TSTEP, &
           XCGMAX_n => XCGMAX, &
           XCDRAG_n => XCDRAG, &
           CRUNOFF_n => CRUNOFF, &
           CTOPREG_n => CTOPREG, &
           CKSAT_n => CKSAT, &
           CSOC_n => CSOC, &
           CRAIN_n => CRAIN, &
           CHORT_n => CHORT, &
           LTRIP_n => LTRIP, &
           LFLOOD_n => LFLOOD, &
           LGLACIER_n => LGLACIER, &
           LVEGUPD_n => LVEGUPD, &           
           LCANOPY_DRAG_n => LCANOPY_DRAG, &  
           LSPINUPCARBS_n => LSPINUPCARBS, &
           LSPINUPCARBW_n => LSPINUPCARBW, &
           XSPINMAXS_n   => XSPINMAXS, &
           XSPINMAXW_n   => XSPINMAXW, &
           NNBYEARSPINS_n => NNBYEARSPINS, &
           NNBYEARSPINW_n => NNBYEARSPINW  
USE MODD_SNOW_PAR, ONLY : &
           LSNOWDRIFT_n => LSNOWDRIFT, &
           LSNOWDRIFT_SUBLIM_n => LSNOWDRIFT_SUBLIM, &
           XALBICE1_n => XALBICE1, &
           XALBICE2_n => XALBICE2, &
           XALBICE3_n => XALBICE3, &
           XRHOTHRESHOLD_ICE_n => XRHOTHRESHOLD_ICE, &
           XZ0ICEZ0SNOW_n => XZ0ICEZ0SNOW, &
           XVAGING_NOGLACIER_n =>  XVAGING_NOGLACIER, &
           XVAGING_GLACIER_n =>  XVAGING_GLACIER           
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=4)  :: CC1DRY
 CHARACTER(LEN=4)  :: CSCOND
 CHARACTER(LEN=3)  :: CSOILFRZ
 CHARACTER(LEN=4)  :: CDIFSFCOND
 CHARACTER(LEN=3)  :: CSNOWRES
 CHARACTER(LEN=4)  :: CALBEDO
 CHARACTER(LEN=4)  :: CROUGH
 CHARACTER(LEN=3)  :: CCPSURF
 CHARACTER(LEN=4)  :: CRUNOFF
 CHARACTER(LEN=3)  :: CTOPREG
 CHARACTER(LEN=3)  :: CKSAT
 CHARACTER(LEN=3)  :: CSOC
 CHARACTER(LEN=3)  :: CRAIN
 CHARACTER(LEN=3)  :: CHORT         
REAL  :: XTSTEP
REAL  :: XOUT_TSTEP
REAL  :: XCGMAX
REAL  :: XCDRAG
REAL  :: XSPINMAXS
REAL  :: XSPINMAXW
INTEGER  :: NNBYEARSPINS
INTEGER  :: NNBYEARSPINW
LOGICAL  :: LPGD
LOGICAL  :: LSURF_EVAP_BUDGET
LOGICAL  :: LSURF_BUDGET
LOGICAL  :: LRAD_BUDGET
LOGICAL  :: LSURF_BUDGETC
LOGICAL  :: LRESET_BUDGETC
LOGICAL  :: LPATCH_BUDGET
LOGICAL  :: LSURF_MISC_BUDGET
LOGICAL  :: LSURF_MISC_DIF
LOGICAL  :: LWATER_BUDGET
REAL     :: XDIAG_TSTEP
REAL     :: XALBICE1, XALBICE2,XALBICE3
REAL     :: XRHOTHRESHOLD_ICE
REAL     :: XZ0ICEZ0SNOW
REAL     :: XVAGING_NOGLACIER,XVAGING_GLACIER
INTEGER  :: N2M
LOGICAL  :: L2M_MIN_ZS
LOGICAL  :: LCOEF
LOGICAL  :: LSURF_VARS
LOGICAL  :: LCH_BIO_FLUX
LOGICAL  :: LCH_NO_FLUX
LOGICAL  :: LTRIP
LOGICAL  :: LFLOOD
LOGICAL  :: LGLACIER
LOGICAL  :: LVEGUPD
LOGICAL  :: LSPINUPCARBS
LOGICAL  :: LSPINUPCARBW
LOGICAL  :: LCANOPY_DRAG
LOGICAL  :: LSNOWDRIFT
LOGICAL  :: LSNOWDRIFT_SUBLIM
 CHARACTER(LEN=6)  :: CCH_DRY_DEP
 CHARACTER(LEN=28) :: CCHEM_SURF_FILE
!
NAMELIST/NAM_ISBAn/CC1DRY,CSCOND,CSOILFRZ,CDIFSFCOND,CSNOWRES,CALBEDO,CROUGH,CCPSURF, &
                     XTSTEP,XCGMAX,XCDRAG,LGLACIER,LCANOPY_DRAG,LVEGUPD
NAMELIST/NAM_SGH_ISBAn/CRUNOFF,CTOPREG,CKSAT,CSOC,CRAIN,CHORT,LTRIP,LFLOOD
NAMELIST/NAM_DIAG_ISBAn/LPGD,LSURF_EVAP_BUDGET,LSURF_MISC_BUDGET,LPATCH_BUDGET, &
                        LSURF_MISC_DIF, LWATER_BUDGET                     
NAMELIST/NAM_DIAG_SURFn/N2M,L2M_MIN_ZS,LSURF_BUDGET,LRAD_BUDGET, &
                          LSURF_BUDGETC,LRESET_BUDGETC,LCOEF,LSURF_VARS  
NAMELIST/NAM_CH_CONTROLn/CCHEM_SURF_FILE
NAMELIST/NAM_CH_ISBAn/LCH_BIO_FLUX,CCH_DRY_DEP,LCH_NO_FLUX
NAMELIST/NAM_SPINUP_CARBn/LSPINUPCARBS,LSPINUPCARBW,XSPINMAXS,XSPINMAXW,NNBYEARSPINS,NNBYEARSPINW
NAMELIST/NAM_CROCUSn/LSNOWDRIFT,LSNOWDRIFT_SUBLIM,XZ0ICEZ0SNOW, XRHOTHRESHOLD_ICE,&
                     XALBICE1, XALBICE2, XALBICE3,XVAGING_NOGLACIER,XVAGING_GLACIER
!
CONTAINS
!
SUBROUTINE INIT_NAM_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_ISBAN',0,ZHOOK_HANDLE)
  CC1DRY = CC1DRY_n
  CSCOND = CSCOND_n
  CSOILFRZ = CSOILFRZ_n
  CDIFSFCOND = CDIFSFCOND_n
  CSNOWRES = CSNOWRES_n
  CALBEDO = CALBEDO_n
  CROUGH = CROUGH_n
  CCPSURF = CCPSURF_n
  XTSTEP = XTSTEP_n
  XOUT_TSTEP = XOUT_TSTEP_n
  XCGMAX = XCGMAX_n
  XCDRAG = XCDRAG_n
  LGLACIER = LGLACIER_n
  LVEGUPD = LVEGUPD_n  
  LCANOPY_DRAG = LCANOPY_DRAG_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_ISBAn

SUBROUTINE INIT_NAM_SGH_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_SGH_ISBAN',0,ZHOOK_HANDLE)
  CRUNOFF = CRUNOFF_n
  CTOPREG = CTOPREG_n
  CKSAT=CKSAT_n
  CSOC=CSOC_n
  CRAIN=CRAIN_n
  CHORT=CHORT_n
  LTRIP=LTRIP_n
  LFLOOD=LFLOOD_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_SGH_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_SGH_ISBAn

SUBROUTINE UPDATE_NAM_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_ISBAN',0,ZHOOK_HANDLE)
  CC1DRY_n = CC1DRY
  CSCOND_n = CSCOND
  CSOILFRZ_n = CSOILFRZ
  CDIFSFCOND_n = CDIFSFCOND
  CSNOWRES_n = CSNOWRES
  CALBEDO_n = CALBEDO
  CROUGH_n = CROUGH
  CCPSURF_n = CCPSURF
  XTSTEP_n = XTSTEP
  XOUT_TSTEP_n = XOUT_TSTEP
  XCGMAX_n = XCGMAX
  XCDRAG_n = XCDRAG
  LGLACIER_n = LGLACIER
  LVEGUPD_n = LVEGUPD  
  LCANOPY_DRAG_n = LCANOPY_DRAG
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_ISBAn

SUBROUTINE UPDATE_NAM_SGH_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_SGH_ISBAN',0,ZHOOK_HANDLE)
  CRUNOFF_n=CRUNOFF
  CTOPREG_n=CTOPREG
  CKSAT_n=CKSAT
  CSOC_n=CSOC
  CRAIN_n=CRAIN
  CHORT_n=CHORT
  LTRIP_n=LTRIP
  LFLOOD_n=LFLOOD
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_SGH_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_SGH_ISBAn

SUBROUTINE INIT_NAM_DIAG_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_DIAG_ISBAN',0,ZHOOK_HANDLE)
  LPGD = LPGD_n
  LSURF_EVAP_BUDGET = LSURF_EVAP_BUDGET_n
  LWATER_BUDGET = LWATER_BUDGET_n
  LSURF_MISC_BUDGET = LSURF_MISC_BUDGET_n
  LSURF_MISC_DIF = LSURF_MISC_DIF_n
  LPATCH_BUDGET = LPATCH_BUDGET_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_DIAG_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_ISBAn

SUBROUTINE UPDATE_NAM_DIAG_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_DIAG_ISBAN',0,ZHOOK_HANDLE)
  LPGD_n = LPGD
  LSURF_EVAP_BUDGET_n = LSURF_EVAP_BUDGET
  LWATER_BUDGET_n = LWATER_BUDGET
  LSURF_MISC_BUDGET_n = LSURF_MISC_BUDGET
  LSURF_MISC_DIF_n = LSURF_MISC_DIF
  LPATCH_BUDGET_n = LPATCH_BUDGET
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_DIAG_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_ISBAn

SUBROUTINE INIT_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP = XDIAG_TSTEP_n  
  N2M = N2M_n
  L2M_MIN_ZS = L2M_MIN_ZS_n
  LSURF_BUDGET = LSURF_BUDGET_n
  LRAD_BUDGET = LRAD_BUDGET_n
  LSURF_BUDGETC = LSURF_BUDGETC_n
  LRESET_BUDGETC = LRESET_BUDGETC_n  
  LCOEF = LCOEF_n
  LSURF_VARS = LSURF_VARS_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURFn

SUBROUTINE UPDATE_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP_n = XDIAG_TSTEP  
  N2M_n = N2M
  L2M_MIN_ZS_n = L2M_MIN_ZS
  LSURF_BUDGET_n = LSURF_BUDGET
  LRAD_BUDGET_n = LRAD_BUDGET 
  LSURF_BUDGETC_n = LSURF_BUDGETC
  LRESET_BUDGETC_n = LRESET_BUDGETC  
  LCOEF_n = LCOEF
  LSURF_VARS_n = LSURF_VARS
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURFn

SUBROUTINE INIT_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE = CCHEM_SURF_FILE_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_CONTROLn

SUBROUTINE UPDATE_NAM_CH_CONTROLn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_CH_CONTROLN',0,ZHOOK_HANDLE)
  CCHEM_SURF_FILE_n = CCHEM_SURF_FILE
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_CH_CONTROLN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_CONTROLn

SUBROUTINE INIT_NAM_CH_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CH_ISBAN',0,ZHOOK_HANDLE)
  LCH_BIO_FLUX = LCH_BIO_FLUX_n
  LCH_NO_FLUX = LCH_NO_FLUX_n
  CCH_DRY_DEP = CCH_DRY_DEP_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CH_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_ISBAn

SUBROUTINE UPDATE_NAM_CH_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_CH_ISBAN',0,ZHOOK_HANDLE)
  LCH_BIO_FLUX_n = LCH_BIO_FLUX
  LCH_NO_FLUX_n = LCH_NO_FLUX
  CCH_DRY_DEP_n = CCH_DRY_DEP
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_CH_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_ISBAn

SUBROUTINE INIT_NAM_SPINUP_CARB_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_SPINUP_CARB_ISBAN',0,ZHOOK_HANDLE)
  LSPINUPCARBS = LSPINUPCARBS_n
  LSPINUPCARBW = LSPINUPCARBW_n  
  XSPINMAXS   = XSPINMAXS_n
  XSPINMAXW   = XSPINMAXW_n  
  NNBYEARSPINS = NNBYEARSPINS_n
  NNBYEARSPINW = NNBYEARSPINW_n
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_SPINUP_CARB_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_SPINUP_CARB_ISBAn

SUBROUTINE UPDATE_NAM_SPINUP_CARB_ISBAn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_SPINUP_CARB_ISBAN',0,ZHOOK_HANDLE)
  LSPINUPCARBS_n = LSPINUPCARBS
  LSPINUPCARBW_n = LSPINUPCARBW  
  XSPINMAXS_n   = XSPINMAXS
  XSPINMAXW_n   = XSPINMAXW  
  NNBYEARSPINS_n = NNBYEARSPINS
  NNBYEARSPINW_n = NNBYEARSPINW
IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:UPDATE_NAM_SPINUP_CARB_ISBAN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_SPINUP_CARB_ISBAn

SUBROUTINE INIT_NAM_CROCUSn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CROCUSn',0,ZHOOK_HANDLE)
  LSNOWDRIFT = LSNOWDRIFT_n
  LSNOWDRIFT_SUBLIM =  LSNOWDRIFT_SUBLIM_n
  XALBICE1 = XALBICE1_n
  XALBICE2 = XALBICE2_n
  XALBICE3 = XALBICE3_n
  XRHOTHRESHOLD_ICE = XRHOTHRESHOLD_ICE_n
  XZ0ICEZ0SNOW = XZ0ICEZ0SNOW_n
  XVAGING_NOGLACIER = XVAGING_NOGLACIER_n
  XVAGING_GLACIER = XVAGING_GLACIER_n
  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CROCUSn',1,ZHOOK_HANDLE)

END SUBROUTINE INIT_NAM_CROCUSn

SUBROUTINE UPDATE_NAM_CROCUSn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CROCUSn',0,ZHOOK_HANDLE)
  LSNOWDRIFT_n = LSNOWDRIFT
  LSNOWDRIFT_SUBLIM_n = LSNOWDRIFT_SUBLIM
  XALBICE1_n = XALBICE1
  XALBICE2_n = XALBICE2
  XALBICE3_n = XALBICE3
  XRHOTHRESHOLD_ICE_n = XRHOTHRESHOLD_ICE
  XZ0ICEZ0SNOW_n = XZ0ICEZ0SNOW
  XVAGING_NOGLACIER_n = XVAGING_NOGLACIER
  XVAGING_GLACIER_n = XVAGING_GLACIER
  IF (LHOOK) CALL DR_HOOK('MODN_ISBA_N:INIT_NAM_CROCUSn',1,ZHOOK_HANDLE)

END SUBROUTINE UPDATE_NAM_CROCUSn

END MODULE MODN_ISBA_n
